using Toybox.Graphics as Gfx;
using Toybox.Math as Math;

import Toybox.Lang;

using C as C;

class HandHr2
{

var length;
var width;
var w2;
var w3;
var h_vert as Array<Array<Number>> = new [3];

var hr_color;
var hr_vert as Array<Array<Number>> or Null;
var min_vert as Array<Number> or Null;

public function initialize(length, width)
{

    me.length = length;
    me.width = width;
    w2 = width / 2;
    w3 = width / 3;

    var w2 = width / 2;
    h_vert[0] = [ -w2, -length ];
    h_vert[1] = [ w2, -length ];
    h_vert[2] = [ 0, -length + width ];

    hr_vert = null;
    min_vert = null;
}

public function show_min(dc, time, time2)
{

    if (time.info.min != time2.info.min) {
        min_vert = C.rotate(-length + w3, time2.info.min * C.ccw);

        dc.setColor(C.YELLOW, C.TRANSPARENT);
        dc.fillCircle(min_vert[0], min_vert[1], w3);
    }
}

public function show(dc, time)
{

    dc.setColor(C.WHITE, C.TRANSPARENT);
    dc.drawText(C.center_x, C.center_y * 1.6, Gfx.FONT_XTINY, time.abbrev, Gfx.TEXT_JUSTIFY_CENTER);

    var h = time.hmins * C.ccw;
    var a = (((Math.PI * 2) * h) / (12*60)) + (Math.PI/2);
    hr_vert = C.translate(h_vert, C.center_x, C.center_y, a);
    hr_color = (time.pm ? C.GREEN : C.RED) | 0xff000000;

    C.set_fill(dc, hr_color);
    dc.fillPolygon(hr_vert);
}

public function refresh(dc)
{

    if (hr_vert != null) {
        C.set_fill(dc, hr_color);
        dc.fillPolygon(hr_vert);
    }

    if (min_vert != null) {
        C.set_fill(dc, C.YELLOW);
        dc.fillCircle(min_vert[0], min_vert[1], w3);
    }
}

}
